using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Default : System.Web.UI.Page 
{

    protected void Page_Load(object sender, EventArgs e)
    {
        RenderForm();
    }

    /// <summary>
    /// This function creates the complete page dynamically and transmites the URL of 
    /// the response page (HTTPResponse.aspx) via the parameter 'flashvars' to the animation.
    /// 
    /// (The page HTTPResponse.aspx provides to the Gallery the requested XML configuration 
    /// file as a stream in an HTTP response.)
    /// </summary>
    private void RenderForm()
    {
        // IMPORTANT: Set Default.aspx as startpage!
        string sAbsoluteUri = Page.Request.Url.AbsoluteUri.Substring(0, Page.Request.Url.AbsoluteUri.IndexOf("Default.aspx", StringComparison.OrdinalIgnoreCase));
        string sMovieName = "3dcubedev.swf";
        string sMoviePath = sAbsoluteUri + sMovieName;
        string sMovieId = "3dcubedev";
        string sFlashVersion = "9.0.115.0";
        string sWMode = "opaque";
        string sSWFPath = sAbsoluteUri + "swfobject.js";

        string sFlashWidth = "550";
        string sFlashHeight = "300";
        string sFlashBgColor = "#ffffff";


        string sFlashQuality = "high";
        string sFlashScale = "noscale";
        string sFlashMenu = "false";

        string sFlashSAlign = "lt";
        
        //---------------------------------------------------------------------------------
        // Create a string concatenated with the URL of your HTTPResponse page
        //
        // You can add as many parameters to the URL as you like. On the basis of these 
        // parameters, HTTPResonse.aspx can later create dynamically the XML configuration 
        // file.
        //
        // "responseurl="
        // The key "responseurl =" must be put in front of the URL of the HTTPResponse Page. It is via 
        // this key that the Flash animation selects the URL from the flashvars. 
        // e.g. responseurl=http://localhost/CSharp_Sample3_HTTPResponse/HTTPResponse.aspx?dataid=12345 
        //---------------------------------------------------------------------------------
        Random random = new Random(); //prevent IE caching
        string sFlashVars = String.Concat("responseurl=", sAbsoluteUri, "HTTPResponse.aspx?dataid=12345x", random.Next(1000).ToString());


        //---------------------------------------------------------------------------------
        // Create the page HTML
        //---------------------------------------------------------------------------------
        // Header
        System.Text.StringBuilder oSB = new System.Text.StringBuilder();
        oSB.Append(@"<!-- saved from url=(0014)about:internet -->");
        oSB.Append(@"<html xmlns=""http://www.w3.org/1999/xhtml"" xml:lang=""en"" lang=""en"">");
        oSB.Append("<head>");
        oSB.Append(@"<meta http-equiv=""Content-Type"" content=""text/html; charset=utf-8"" />");
        oSB.Append(@"<title>3DCube</title>");
        oSB.Append(@"<style type=""text/css"">.description {font-family: Verdana; font-size: 12px; color:#333333;}</style>");

        //BEGIN embed 3D Cube / include SWFObject Java file 
        oSB.Append(@"<script type=""text/javascript"" src=""swfobject.js""></script>");
        //END embed 3D Cube 

        oSB.Append(@"</head>");
        oSB.Append(@"<body>");
        oSB.Append(@"<span class=""description""><strong>C# Sample 3 - Create a 3D Cube dynamically via an HTTP Request/Response</strong><br /><br />This example shows how a dynamically created 3D Cube can be configured via an HTTP Request/Response and filled with data.<br /><br />(Visual Studio Users: Set Default.aspx as startpage!)</span><br /><br />");

        //BEGIN embed 3D Cube

        //---------------------------------------------------------------------------------
        //This <div> is replaced by the Flash content! (see "SWFObject embed by Geoff Stearns ..." below)
        //Place your alternate content here and users without the Flash plugin 
        //or with Javascript turned off will see this.
        //---------------------------------------------------------------------------------
        oSB.Append(@"<div id=""flashcontent"">");
        oSB.Append(@"<br />");
        oSB.Append(@"<br />");
        oSB.Append(@"<center>");
        oSB.Append(@"<a target=""_blank"" href=""http://www.macromedia.com/go/getflash/"">");
        oSB.Append(@"<img border=""0"" alt="""" src=""images/getflash.png"" />");
        oSB.Append(@"</a>");
        oSB.Append(@"</center>");
        oSB.Append(@"</div>");

        //---------------------------------------------------------------------------------
        // SWFObject embed by Geoff Stearns geoff@deconcept.com http://blog.deconcept.com/swfobject/
        //---------------------------------------------------------------------------------
        oSB.Append(@"<script type=""text/javascript"">");
        oSB.Append(@" var so = new SWFObject(");
        oSB.Append(@""""); oSB.Append(sMovieName);      oSB.Append(@""", ");
        oSB.Append(@""""); oSB.Append(sMovieId);        oSB.Append(@""", ");
        oSB.Append(@""""); oSB.Append(sFlashWidth);     oSB.Append(@""", ");
        oSB.Append(@""""); oSB.Append(sFlashHeight);    oSB.Append(@""", ");
        oSB.Append(@""""); oSB.Append(sFlashVersion);   oSB.Append(@""", ");
        oSB.Append(@""""); oSB.Append(sFlashBgColor);   oSB.Append(@"""");
        oSB.Append(@"); ");

        //Additional Parameters
        oSB.Append(@"so.addParam(""quality"", """);     oSB.Append(sFlashQuality);  oSB.Append(@"""); ");
        oSB.Append(@"so.addParam(""scale"", """);       oSB.Append(sFlashScale);    oSB.Append(@"""); ");
        oSB.Append(@"so.addParam(""menu"", """);        oSB.Append(sFlashMenu);     oSB.Append(@"""); ");
        oSB.Append(@"so.addParam(""salign"", """);      oSB.Append(sFlashSAlign);   oSB.Append(@"""); ");
        oSB.Append(@"so.addParam(""wmode"", """);       oSB.Append(sWMode);         oSB.Append(@"""); ");
        oSB.Append(@"so.addParam(""flashVars"", """);   oSB.Append(sFlashVars);     oSB.Append(@"""); ");  //FlashVars Parameter!!!

        //SWFObject write
        oSB.Append(@"so.write(""flashcontent""); ");
        oSB.Append(@"</script>");

        //END embed 3D Cube

        //Description
        oSB.Append(@"<div class=""description""><br /><br />In <strong>default.aspx.cs</strong> (code behind), the URL of the response page is transmitted to the Cube via property <strong>flashvars</strong>.<br />The Cube will then automatically call up the transmitted page and expects in return the XML configuration file as stream in a <strong>HTTP response</strong>.<br>The page <strong>HTTPResponse.aspx.cs</strong> (code behind) provides to the Cube the requested XML configuration file as a stream in a <strong>HTTP response</strong>.<br /><br /><strong><u>Flow:</u></strong><br /><br /><strong>1.</strong> <strong>Default.aspx.cs</strong> (code behind) creates the URL of the HTTP Response Page (HTTPResponse.aspx) with any number of parameters.<br><br /><strong>2.</strong> <strong>Default.aspx.cs</strong> calls up the Cube and transmits the URL via property <strong>flashvars</strong>.<br /><br /><strong>3.</strong> The Cube calls up the page transmitted in the property <strong>flashvars</strong>.<br /><br /><strong>4.</strong> <strong>HTTPResponse.aspx</strong> will be called up by the Cube and creates the XML configuration file on the basis of the transmitted parameter.<br /><br /><strong>5.</strong> <strong>HTTPResponse.aspx.cs</strong> (code behind) provides the XML configuration file as <strong>HTTP response</strong> back to the Cube.<br /><br /><strong>6.</strong> The Cube is happy and displays the images :-)</div>");

        //Close page
        oSB.Append("</body>");
        oSB.Append("</html>");

        ////Save string to the hard disk for control.
        //System.IO.StreamWriter streamWriter = new System.IO.StreamWriter(@"c:\3dcube.html");
        //streamWriter.Write(oSB.ToString());
        //streamWriter.Close();

        //---------------------------------------------------------------------------------
        // Write the string to the HTTP response output stream
        //---------------------------------------------------------------------------------
        Page.Response.Write(oSB.ToString());
    }
}
