<?php

//---------------------------------------------
//load cube settings
//---------------------------------------------
    
if (file_exists('cube/3dcube.xml'))
{
    $xml = simplexml_load_file('cube/3dcube.xml');
}
else
{
    die('settings file is missing');
}

// overwrite some attributes
$xml->Images['BackGroundVisible'] = 'true';
$xml->Images['BackGroundPath'] = 'cube/images/background.jpg';

//---------------------------------------------
//hardcoded sample entries
//---------------------------------------------

// load 20 images
for ($i = 0; $i < 20; $i++) {      
  $image[$i] = Array(
    'ImagePath' 			=>		'cube/images/'. (($i < 10) ? '0'.$i : $i) .'.jpg',
    'ImageLink'				=>		'http://www.3dcarousel.com',
    'ImageLinkTarget' =>		'_blank',
    'Content1'				=>		'',
    'Content2'				=>		'',
    'JSFunction'			=>		''
    );
}

// static content 1
$static[0] = Array(
  'Attributes'  =>  Array(
          'HTML'          =>  'false',
          'AntiAliasing'  =>  'false',
          'Align'         =>  'left',
          'Bold'          =>  'false',
          'Italic'        =>  'false',
          'Font'          =>  'Verdana',
          'FontColor'     =>  '#222222',
          'FontSize'      =>  '14',
          'Leading'       =>  '0',
          'Underline'     =>  'false',
          'Left'          =>  '290',
          'Top'           =>  '10',
          'Width'         =>  '160',
          'Height'        =>  '50',
          'TopMost'       =>  'true',
          'BgColor'       =>  '',
          'Border'        =>  'false',
          'BorderColor'   =>  '#bc0000',
          'VisibleOnCubePage'   =>  'true',
          'VisibleOnDetailPage' =>  'true'
      ),
  'Content'     =>  'Human Expressions'
  );
  
  // static content 2
$static[1] = Array(
  'Attributes'  =>  Array(
          'HTML'          =>  'false',
          'AntiAliasing'  =>  'false',
          'Align'         =>  'left',
          'Bold'          =>  'false',
          'Italic'        =>  'false',
          'Font'          =>  'Verdana',
          'FontColor'     =>  '#636363',
          'FontSize'      =>  '11',
          'Leading'       =>  '0',
          'Underline'     =>  'false',
          'Left'          =>  '480',
          'Top'           =>  '355',
          'Width'         =>  '260',
          'Height'        =>  '60',
          'TopMost'       =>  'true',
          'BgColor'       =>  '',
          'Border'        =>  'false',
          'BorderColor'   =>  '#bc0000',
          'VisibleOnCubePage'   =>  'true',
          'VisibleOnDetailPage' =>  'true'
      ),
  'Content'     =>  'This 3D Cube contains 20 images. Refresh your browser to show a different selection.'
  );

// hardcoded sample entries - END

foreach ($image as $entry)
{
	$tag = $xml->Images->addChild('Image');
	foreach ($entry as $key => $value)
	{
		$tag->addChild($key, '<![CDATA['.htmlentities($value).']]>');
	}
}

foreach ($static as $entry)
{
	$tag = $xml->StaticContents->addChild('StaticContent');
	
	foreach ($entry['Attributes'] as $a_key => $a_value)
	{
    $tag->addAttribute($a_key, $a_value);
	}
	
	$tag->addChild('Content', '<![CDATA['.htmlentities($entry['Content']).']]>');
}

print_r(html_entity_decode($xml->asXML()));

?>